unit uVerbose;
{************************************************************************
 * This program is  free software; you can redistribute it  and modify it
 * under the terms of the GNU  General Public License as published by the
 * Free Software Foundation; either version 2 of the license  or (at your
 * option) any later version.
 ***********************************************************************}

interface

uses Windows, SysUtils;

procedure ConsoleColor(intense:boolean=false; r:boolean=true; g:boolean=true; b:boolean=true);

procedure ShowUsage();
procedure ShowInputInfo(sourcefile:string; width:cardinal; height:cardinal);
procedure ShowWarning(msg:string; red:boolean=false);
procedure ShowInfo(msg:string; green:boolean=false);

const
  APPVER = '0.1';
  DEBUG = false;

implementation

procedure ConsoleColor(intense:boolean=false; r:boolean=true; g:boolean=true; b:boolean=true);
var col_r, col_g, col_b, color_intense:integer;
begin
color_intense := 0;         if intense then color_intense := FOREGROUND_INTENSITY;
col_r := FOREGROUND_RED;    if not r then col_r := 0;
col_g := FOREGROUND_GREEN;  if not g then col_g := 0;
col_b := FOREGROUND_BLUE;   if not b then col_b := 0;

SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), col_r or col_g or col_b or color_intense);
end;


procedure ShowUsage();
begin
 ConsoleColor(true); Writeln('PNG Resize v'+APPVER); ConsoleColor();
 Writeln('==============================');
 Writeln('Usage:');
 ConsoleColor(true,true,true,false);
 Writeln(#9+'pngresize.exe <Zx> <sprite> [<output>]');
 ConsoleColor();
 Writeln('----------');
 ConsoleColor(true); Write('SPRITE'+#9#9); ConsoleColor(); Writeln('Source z0 PNG sprite');
 ConsoleColor(true); Write('ZX'+#9#9); ConsoleColor(); Writeln('Output zoom level');
 Writeln(#9#9+'    Possible values:');
 ConsoleColor(true,false); Write(#9#9#9+'z1'+#9); ConsoleColor(); Writeln('Zoom level 1 (z1)');
 ConsoleColor(true,false); Write(#9#9#9+'z2'+#9); ConsoleColor(); Writeln('Zoom level 2 (z2)');
 ConsoleColor();
 ConsoleColor(true); Write('OUTPUT'+#9#9); ConsoleColor(); Writeln('Output PNG sprite filename (OPTIONAL)');
 Writeln(#9#9+'    If no output name is given, sprite name will be used to');
 Writeln(#9#9+'    create the output file.');
 ConsoleColor();
 Writeln('----------');

 ConsoleColor(true, true, false,false);
 Writeln('WARNING: Mask files are currently UNSUPPORTED!');
 ConsoleColor();


 if DEBUG then
    begin
    ConsoleColor(true,true,false,false);
    writeln('Press [ENTER] to exit');

    ConsoleColor(false,false,false,false);
    Readln;
    Consolecolor();
    end;
end;


procedure ShowInputInfo(sourcefile:string; width:cardinal; height:cardinal);
begin
write('Input sprite: '); ConsoleColor(true,true,true,false); write(ExtractFileName(sourcefile)); ConsoleColor();
write(#9+#9+'Dimensions: ');
        ConsoleColor(true); write(width); ConsoleColor();
        write('x');
        ConsoleColor(true); writeln(height); ConsoleColor();
end;

procedure ShowWarning(msg:string; red:boolean=false);
begin
  if red then ConsoleColor(true, true, false, false)
         else ConsoleColor(true, true, true, false);
  Writeln('WARNING: '+msg);
  ConsoleColor();
end;

procedure ShowInfo(msg:string; green:boolean=false);
begin
  if green then ConsoleColor(true, false, true, false)
         else ConsoleColor(true);
  Writeln(msg);
  ConsoleColor();
end;

end.
